const { CloudWatchLogs } = require("@aws-sdk/client-cloudwatch-logs");
const { delaySeconds } = require("./utils");
class CloudWatchClient {
    constructor (configuration) {
        this.client = new CloudWatchLogs(configuration);
    }

    async tailLogStream(logGroupName, logStreamName, nextToken){
        // console.log(nextToken)
        const logEvents = await this.client.getLogEvents({
            logStreamName,
            logGroupName,
            nextToken
        })
    
        const lines = logEvents.events.map(({ message, timestamp }) => `${new Date(timestamp).toISOString()}\t${message}`);
    
        if (lines.length) console.log(lines.join("\n"));
    
        await delaySeconds(5);
        // TODO I don"t like that this is unstoppable. The interface should allow the consumer to close without exiting the process
        await this.tailLogStream(logGroupName, logStreamName, logEvents.nextForwardToken);
    }
}

module.exports = { CloudWatchClient };